#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <string.h>
#include <time.h>
#include <sys/errno.h>
#include <sys/param.h>
#include <sys/time.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/time.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <pwd.h>

/*
** #defines from LPRng errorcodes.h
*/
#define JSUCC    0     /* done */
/* from 1 - 31 are signal terminations */
#define JFAIL    32    /* failed - retry later */
#define JABORT   33    /* aborted - do not try again, but keep job */
#define JREMOVE  34    /* failed - remove job */
#define JACTIVE  35    /* active server - try later */
#define JIGNORE  36    /* ignore this job - not used! */
#define JHOLD    37    /* hold this job */
#define JNOSPOOL 38    /* no spooling to this queue */
#define JNOPRINT 39    /* no printing from this queue  */
#define JSIGNAL  40    /* killed by unrecognized signal */
#define JFAILNORETRY  41 /* no retry on failure */

/*
** headers to make -Wall shut up
*/
void *malloc(size_t size);
void free(void *ptr);
void *realloc(void *ptr, size_t size);
unsigned long int inet_addr(const char *cp);

typedef enum { e_err=(-1), e_ok=0} err_t;
typedef enum { true=1, false=0} bool_t;

typedef struct
{
  char *printername; /* -P */
  char *username;    /* -n */
  char *jobname;     /* -J */
  char *jobnumber;   /* -j */
  char *hostname;    /* -h */
  char *zopts;       /* -Z */
  char *datapath;    /* -e */
  bool_t banner;     /* --banner */
  char *realname;    /* synthetic */
  char *comment;     /* -S */
}
options_t;

options_t options={NULL,NULL,NULL,NULL,NULL,NULL,NULL,false,NULL,NULL};

err_t readoptions(int argc, char **argv)
{
  int i;
  struct passwd *pwd;

  for (i=1;i<argc;i++)
    {
      if (strncmp("-P",argv[i],2)==0)
	options.printername=strdup(argv[i]+2);
      else if (strncmp("-n",argv[i],2)==0)
	options.username=strdup(argv[i]+2);
      else if (strncmp("-J",argv[i],2)==0)
	options.jobname=strdup(argv[i]+2);
      else if (strncmp("-j",argv[i],2)==0)
	options.jobnumber=strdup(argv[i]+2);
      else if (strncmp("-h",argv[i],2)==0)
	options.hostname=strdup(argv[i]+2);
      else if (strncmp("-Z",argv[i],2)==0)
	options.zopts=strdup(argv[i]+2);
      else if (strncmp("-e",argv[i],2)==0)
	options.datapath=strdup(argv[i]+2);
      else if (strncmp("--banner",argv[i],8)==0)
	options.banner=true;
      else if (strncmp("-S",argv[i],2)==0)
	options.comment=strdup(argv[i]+2);
    }

  if (!(options.printername
	&& options.hostname
	&& options.jobname
	&& options.username
	&& options.datapath))
    return(e_err);

  pwd=getpwnam(options.username);
  if (pwd) options.realname=strdup(pwd->pw_gecos);

  return(e_ok);
}

err_t init(int argc, char **argv)
{
  char buf[512];

  if (readoptions(argc, argv)==e_err)
    {
      return(e_err);
    }
  return(e_ok);
}

#define CHUNK 8192

int main(int argc, char **argv, char **envp)
{
  int fd;
  char filename[256];
  char buf[CHUNK];
  int bytes;
  int status;

  if (init(argc, argv)==e_err)
    {
      exit(JABORT);
    }

  sprintf(filename,"/tmp/%s-%s",options.username,options.jobname);
  fd=open(filename,O_WRONLY|O_CREAT,0600);
  if (fd<0)
    {
      perror("open()");
      return(JABORT);
    }

  while((bytes=read(0,buf,CHUNK))>0)
    if (write(fd,buf,bytes)<bytes)
      {
	perror("write()");
	close(fd);
	unlink(filename);
	return(JABORT);
      }
  close(fd);

  sprintf(buf,"/fs/lprng/bin/mpack -s \"Your print job\" %s %s",filename,options.username);
  system(buf);
  sleep(5);
  unlink(filename);
  return(JSUCC);
}

